#ifndef _HERMIT_IP_H_
#define _HERMIT_IP_H_

#define IP_VERSION 4
#define LEN_IP_Header 20

typedef enum _ip_proc_mode {
	ICMP_WAIT,
	TCP_WAIT,
	UDP_WAIT,
} ip_proc_mode;

typedef struct _ip_frame {
	unsigned char header_len:4,
		      version:4;
	unsigned char diffserv;
	unsigned short data_len;
	unsigned short id;
	unsigned short flag;
#define IP_CE		0x8000		/* Flag: "Congestion"		*/
#define IP_DF		0x4000		/* Flag: "Don't Fragment"	*/
#define IP_MF		0x2000		/* Flag: "More Fragments"	*/
#define IP_OFFSET	0x1FFF		/* "Fragment Offset" part	*/

	unsigned char  ttl; /* time to live */
	unsigned char  protocol;
	unsigned short checksum;
	unsigned char  src_ipaddr[4];
	unsigned char  dst_ipaddr[4];
} __attribute__((packed)) ip_frame;

typedef enum _ip_protocol_id {
	IP_PROTOCOL_ICMP = 0x01,
	IP_PROTOCOL_TCP  = 0x06,
	IP_PROTOCOL_UDP  = 0x11,
} ip_protocol_id;

int ip_send(const unsigned char *dst_ipaddr, const unsigned char protocol,
	    const void *pbuf, const unsigned int pbuflen);

int ip_proc(const int mode, void **pbuf, unsigned int *pbuflen);

#endif
